local addonInfo, privateVars = ...

---------- init namespace ---------

if not privateVars.langTexts then privateVars.langTexts = {} end

local lang = nil

---------- init language texts ---------

if ( Inspect.System.Language() == "French"  ) then

	lang = {	addonUpdate	= '<font color="#FF6A00">New version <font color="#FFFFFF">%s</font> of addon <font color="#FFFFFF">%s</font> available. Please update the addon.</font>',
            tooltips = {  moveToggle = 'Activate this box to move the window',
									       hideToggle = 'Click here to hide the window'},
						requiredFaction = 'Requires %s:\n%s',
						factionList = {"Friendly", "Decorated", "Honored", "Revered", "Glorified", "Venerated"},
						yes  = 'Yes',
						no = 'No',
						ok = 'Ok',
						cancel = 'Cancel',
						bop = 'Bind on Pickup',
						account = 'Account Bound',
						bound = 'Soldbound',
						copy		= 'copy',
						paste		= 'paste',
						color		= 'color',
						boundText		= { equip = 'Bin on equip', use = "Bind on use", pickup = "Bind on pickup", account = "Account bound"},
						dps = "Damage per second: %.1f\n%d-%d Damage all %1.f seconds",
						stats		= { armor 		= "Armor", 
    										block 		= "Block",
    										critAttack	= "Physical Crit",
    										critPower	= "Critical Power",
    										critSpell	= "Spell Hit",
    										deflect		= "Deflect",
    										dexterity	= "Dexterity",
    										dodge		= "Dodge",
    										endurance	= "Endurance",
    										hit			= "Hit",
    										intelligence= "Intelligence",
    										parry		= "Parry",
    										powerAttack = "Attackpower",
    										powerSpell	= "Spellpower",
    										resistAir	= "Resistance Air",
    										resistAll	= "Resistance All",
    										resistDeath	= "Resistance Death",
    										resistEarth	= "Resistance Earth",
    										resistFire	= "Resistance Fire",
    										resistLife	= "Resistance Life",
    										resistWater	= "Resistance Water",
    										strength	= "Strength",
    										wisdom		= "Wisdom",
    										valor		= "Valor",
    										toughness	= "Toughness",
    										vengeance	= "Vengeance" },				
						equip		= "Equip: %s",
						use			= "Use: %s",		
						requiredLevel = "Requires level %d",
						requiredCalling = "Calling: %s",
						callings		= { mage = "Mage", rogue = "Rogue", warrior = "Warrior", cleric = "Cleric"}		
  }
  
	lang.items = {txtCape = 'Cape',
            		txtStaff = 'Bâton',
            		txtTwoHand = 'A deux mains',
            		txtHammer = 'Marteau',
            		txtPolearm = 'Arme d\'hast',
            		txtSword = 'Epée',
            		txtAxe = 'Hache',
            		txtMace = 'Masse',
            		txtDagger = 'Dague',
            		txtEssenceLesser = 'Essence inférieure',
            		txtEssenceGreater = 'Essence supérieure',
            		txtMainhand = 'Main principale',
            		txtOneHand = 'Une main',
            		txtWand = 'Baguette',
            		txtGun = 'Arme à feu',
            		txtBow = 'Arc',
            		txtHelmet = 'Tête',
            		txtPlate = 'Armure de plates',
            		txtLeather = 'Cuir',
            		txtChain = 'Armure de mailles',
            		txtCloth = 'Etoffe',
            		txtShoulders = 'Epaules',
            		txtChest = 'Torse',
            		txtGloves = 'Mains',
            		txtBelt = 'Taille',
            		txtLegs = 'Jambes',
            		txtFeet = 'Pieds',
            		txtRing = 'Anneau',
            		txtOffhand = 'Main secondaire',
            		txtNeck = 'Cou',
            		txtShield = 'Bouclier',
            		txtTrinket = 'Talisman',
            		txtPet = 'Compagnon',
            		txtCurrency = 'Monnaie',
            		txtMount = 'Monture',
            		txtOther = 'Autre',
            		txtSynergyCrystal = 'Cristal de synergie',
            		txtFocus = 'Focus planaire',
            		txtRecipe = 'Recette',
            		txtLure = 'Leurre',
            		txtHusk = 'Gradalis',
            		txtRune = 'Rune',
            		txtConsumable = 'Consommable',
            		txtCostume = 'Costume',
            		txtTitle = 'Titre',
            		txtContainer = 'Boîte',
            		txtSeal = 'Sceau',
            		txtDimension = 'Dimension item',
            		txtItemUpgrade = 'Upgrade item',
            		txtReagent = "Ingrédient d'artisanat"
	}
	
	lang.profession = {  txtApothecary = 'Apothicaire',
                  		txtArtificer = 'Artificier',
                  		txtRunecrafter = 'Fabricant de runes',
                  		txtWeaponsmith = 'Fabricant d\'armes',
                  		txtOutfitter = 'Tailleur',
                  		txtArmorsmith = 'Fabricant d\'armures'
	}
	
	lang.factionNames = { ["Arcane Hand"]= "Main d'arcane",
                        ["Atragarians"]= "Atragarians",
                        ["Caretakers"]= "Reliquaires",
                        ["Cerulean Rhenke"]= "Rhenke céruléen",
                        ["Defiants"]= "Renégats",
                        ["Dragonslayer Covenant"]= "Alliance des Tueurs de dragons",
                        ["Eldritch Seekers"]= "Chercheurs eldritch",
                        ["Eldritch Vanguard"]= "Avant-garde eldritch",
                        ["Ember Scholars"]= "Érudits de braise",
                        ["Empyreal Alliance"]= "Alliance empyréenne",
                        ["Eternal City Survivors"]= "Survivants de la Cité Éternelle",
                        ["Freemarch Wardens"]= "Gardes de la Marche",
                        ["Gloamwood Waykeepers"]= "Gardes-voies du Bois du Crépuscule",
                        ["Granite Falls"]= "Chutes de Granite",
                        ["Guardians"]= "Gardiens",
                        ["Hailol"]= "Hailol",
                        ["Icewatch"]= "L’Œil-glacé",
                        ["Iron Claw Trappers"]= "Trappeurs Griffes de fer",
                        ["Kelari Expedition"]= "Expédition kelari",
                        ["Manugo League"]= "Ligue de Manugo",
                        ["Mendicant Order"]= "Ordre mendiant",
                        ["Mercurial Savants"]= "Savants lunatiques",
                        ["Necropolis Caretakers"]= "Reliquaires de la Nécropole",
                        ["Noble Guard"]= "Garde noble",
                        ["Order of Life Serene"]= "Ordre de la Vie Sereine",
                        ["Order of Mathos"]= "Ordre de Mathos",
                        ["Order of Purity"]= "Ordre de la Pureté",
                        ["Order of the Death Serpent"]= "Ordre du Serpent de la Mort",
                        ["Order of the Flame"]= "Ordre de la Flamme",
                        ["Pelagic Order"]= "Ordre pélagien",
                        ["Quarry Rats"]= "Rats de carrière",
                        ["Quicksilver Scholars"]= "Érudits de l'Académie de Vif-Argent",
                        ["Red Scar Trackers"]= "Pisteurs de Rouge-balafre",
                        ["Ridgerunner Mercenaries"]= "Mercenaires Cavalarêtes",
                        ["Runic Sages"]= "Sages runiques",
                        ["Students of the Vale"]= "Étudiants du Val",
                        ["The Achyati"]= "Les Achyati",
                        ["The Farclan"]= "Le Clan-Lointain",
                        ["The Ghar"]= "Les Ghars",
                        ["The Grim Disciples"]= "Les Sinistres Disciples",
                        ["The Keepers"]= "Le Phalanstère",
                        ["The Lycini"]= "Les Lycinis",
                        ["The Moribund"]= "Les Moribonds",
                        ["The Onir"]= "Les Onir",
                        ["The Order of the Eye"]=  "L'Ordre de l'Œil",
                        ["The Qaijiri"]= "Les Qaijiri",
                        ["The Runeguard"]= "La Garde runique",
                        ["The Seekers"]= "Les Chercheurs",
                        ["The Shale Collegiate"]= "La Collégiale du Schiste",
                        ["The Storm Guard"]= "La Garde-tempête",
                        ["The Storm Inquisition"]= "L’Inquisition de la Tempête",
                        ["The Unseen"]= "Les Invisibles",
                        ["The Unspoken"]= "L’Implicite",
                        ["Torvan Hunters"]= "Chasseurs torvains",
                        ["Whitefall Brigade"]= "Brigade des Chutes blanches",
                        ["Zephyrian Collective"]= "Collectif Zéphyrien"	  
	}
	
	privateVars.langTexts = lang
	
end