local addonInfo, internal = ...

---------- init namespace ---------

local intFct   = internal.fct

---------- addon internal function block ---------

function intFct.nkPanelPlugin (menuItems)

	local plugin = nkPanel.api.plugin('nkRadial', true, false)

	plugin:SetTitle('nkRadial')
	plugin:SetThumb('nkRadial', 'gfx/nkPanelIcon.png')

	local body = plugin:CreateBody()
	
	local menu = EnKai.uiCreateFrame("nkMenu", 'nkRadial.panelMenu', body)
		
	menu:SetFontSize(nkPanelSetup.menuFontSize)
	--menu:SetWidth(120)
	menu:SetBackgroundColor(0, 0, 0, 0)
	menu:SetLabelColor(1, 1, 1, 1)
	menu:SetBorderColor(0, 0, 0, 0)
	menu:SetPoint("TOPLEFT", body, "TOPLEFT", 2, 2)
	
	local items = {}
	local subMenus
	
	for k, v in pairs(menuItems) do				
		if v.seperator == true then
			menu:AddSeparator()					
		elseif v.callBack ~= nil then
			menu:AddEntry({ closeOnClick = true, label = v.label, macro = v.macro, callBack = function() v.callBack() end })
		else
			menu:AddEntry({ closeOnClick = true, label = v.label, macro = v.macro, callBack = nil })
		end
	end
					
	body:SetHeight(menu:GetHeight()+4)
	body:SetWidth(menu:GetWidth()+4)
	
	function plugin:GetMenu() return menu end
	function plugin:GetBody() return body end
	
	return plugin

end