local addonInfo, internal = ...

---------- init namespace ---------

local intFct        = internal.fct
local uiElements    = internal.uiElements

---------- addon internal function block ---------

function intFct.tutorial ()

  local name = "nkRadial.tutorial"

  local window = EnKai.uiCreateFrame("nkWizardInfo", name, uiElements.contextTop)
  
  window:SetupStep(1, {label = 'the action bar', desc= "This is how the action bar works", pointers = { 
                                                                                { from = {20, 20}, to = {180, 120}, text = "Click the big circle to show the outer section buttons"},
                                                                                { from = {460, 20}, to = {250, 60}, text = "Each of the outer section buttons represents a category of items and / or abilities"},
                                                                                { from = {20 , 100}, to = {25, 110}, text = "Click on an action button to use the item or ability"},
                                                                                { from = {460, 120}, to = {265, 130}, text = "Click on one of the outer section buttons and the addon will show the action buttons for that category"},
                                                                                { from = {20, 180}, text = "You cannot open or close a section if you are in comabt!"},
                                                                                { from = {20, 250}, text = "Move the circle by right clicking and dragging it to the new position!"},
                                                                                }, texture = {addon = "nkRadial", path = "gfx/wizard1.png"}})
  window:SetupStep(2, {label = 'the configuration', desc= "The addon configuration", pointers = { 
                                                                                { from = {20, 20}, to = {20, 20}, text = "You can change the scale, visibility out of combat and the angle of the addon"},
                                                                                { from = {20, 110}, to = {20, 100}, text = "Using the checkbox you can toggle a category of items and / or abilities"},
                                                                                { from = {460, 20}, to = {160, 65}, text = "You can change the icon of a category by clicking on it. The border will turn yellow. Hover over any item or ability to apply that icon to the category. Click again on the icon in the configuration to apply the change."},
                                                                                { from = {20, 200}, to = {60, 165}, text = "You can change a slot by clicking on it and then hovering an ability or item with your mouse to apply it to that slot. Click again on the slot to apply the change."},
                                                                                { from = {460, 220}, text = "<font color='#FF0000'>Please note that only corresponding items and / or abilities can be applied to a category.</font>"} 
                                                                                }, texture = {addon = "nkRadial", path = "gfx/wizard2.png"}})
  window:SetTitle("nkRadial Tutorial")
  window:SetTextureWidth(300)
  window:SetPoint("CENTER", UIParent, "CENTER")
  window:SetVisible(true)
  window:SetHeight(550)
  
  return window  
  
end