local addonInfo, internal = ...

---------- init namespace ---------

local intFct     = internal.fct
local uiElements = internal.uiElements
local data       = internal.data

---------- init local variables ---------

local _buttonsShown     = false
local _buttonshownTimer = nil

local _designsInner = {
  default       = { "nkRadial", "gfx/center.png"},
  bluecircle    = { "nkRadial", "gfx/centerBlue.png"},
  redcircle     = { "nkRadial", "gfx/centerRed.png"},
  greencircle   = { "nkRadial", "gfx/centerGreen.png"},
  cyancircle    = { "nkRadial", "gfx/centerCyan.png"},
  Lifeismystery = { "Rift", "WE_VFX_CenterTwirl_yellow.png.dds"},
  abstract      = { "Rift", "Bkgnd.png.dds"},
  abstractblue  = { "Rift", "Bkgnd_Aqua.png.dds"},
  abstractyellow= { "Rift", "Bkgnd_Yellow.png.dds"},
  burst         = { "Rift", "burst.png.dds"},
  abstractred   = { "Rift", "Centerflair_Defiant.png.dds"},
  abstract2     = { "Rift", "CharacterSheet_I217.dds"},
  roundbutton   = { "Rift", "ControlPoint_ContestedGlow.png.dds"},
  cycleegreen   = { "Rift", "cycle_green.png.dds"},
  cycleyellow   = { "Rift", "cycle_yellow.png.dds"},
  defiant       = { "Rift", "Defiant_Color_256.png.dds"},
  guardian      = { "Rift", "Guardian_Color_256.png.dds"},
  cyclered      = { "Rift", "GuardianSymbol_Yellow.png.dds"},
  square        = { "Rift", "HeaderButton_Normal_Over.png.dds"},
  square2       = { "Rift", "HeaderButton_Normal_Up.png.dds"}
}

local _designsOutter = {
  default       = { "nkRadial", "gfx/outter.png", 65, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, true},
  bluecircle    = { "nkRadial", "gfx/outterBlue.png", 65, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, false},
  redcircle     = { "nkRadial", "gfx/outterRed.png", 65, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, false},
  greencircle   = { "nkRadial", "gfx/outterGreen.png", 65, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, false},
  cyancircle    = { "nkRadial", "gfx/outterCyan.png", 65, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, false},
  Lifeismystery = { "Rift", "WE_VFX_CenterTwirl_yellow.png.dds", 28, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  abstract      = { "Rift", "Bkgnd.png.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  abstractblue  = { "Rift", "Bkgnd_Aqua.png.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  abstractyellow= { "Rift", "Bkgnd_Yellow.png.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  burst         = { "Rift", "burst.png.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  abstractred   = { "Rift", "Centerflair_Defiant.png.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  abstract2     = { "Rift", "CharacterSheet_I217.dds", 80, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  roundbutton   = { "Rift", "ControlPoint_ContestedGlow.png.dds", 60, {type = 'solid', r = 0, g = 0, b = 0, a = 1}, {r = 0, g = 0, b = 0, a = 1, thickness = 1 }, false},
  cycleegreen   = { "Rift", "cycle_green.png.dds", 40, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  cycleyellow   = { "Rift", "cycle_yellow.png.dds", 40, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  defiant       = { "Rift", "Defiant_Color_256.png.dds", 50, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  guardian      = { "Rift", "Guardian_Color_256.png.dds", 50, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  cyclered      = { "Rift", "GuardianSymbol_Yellow.png.dds", 40, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  square        = { "Rift", "HeaderButton_Normal_Over.png.dds", 34, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false},
  square2       = { "Rift", "HeaderButton_Normal_Up.png.dds", 34, {type = 'solid', r = 0, g = 0, b = 0, a = 0}, {r = 0, g = 0, b = 0, a = 0, thickness = 1 }, false}
}

---------- init variables ---------

---------- local function block ---------

local function _uiCenter ()

  local name = "nkRadial.center"

  local center = EnKai.uiCreateFrame("nkTexture", name, uiElements.context)  
  center:SetPoint("CENTER", UIParent, "CENTER", nkRadialSetup.x, nkRadialSetup.y)
  center:SetWidth(75 * nkRadialSetup.scale)
  center:SetHeight(75 * nkRadialSetup.scale)
  
  function center:destroy()
    EnKai.uiAddToGarbageCollector ('nkTexture', center)
  end
  
  local offSetX, offSetY = UIParent:GetWidth()/2, UIParent:GetHeight()/2
  
  center:EventAttach(Event.UI.Input.Mouse.Cursor.In, function (self)    
    
    if Inspect.System.Secure() == true then return end
    center:SetAlpha(1)
    
  end, center:GetRealName() .. ".Cursor.In")
  
  center:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function (self)    
    
    if _buttonsShown == true then return end
    if Inspect.System.Secure() == true then return end        
    
    center:SetAlpha(nkRadialSetup.mouseOverAlpha)
    
  end, center:GetRealName() .. ".Cursor.Out")
  
  center:EventAttach(Event.UI.Input.Mouse.Middle.Down, function (self)    
    
    intFct.ShowConfig()
    
  end, center:GetRealName() .. ".Middle.Down")
  
  center:EventAttach(Event.UI.Input.Mouse.Right.Down, function (self)    
    
    if Inspect.System.Secure() == true or nkRadialSetup.locked == true then return end
    
    self.leftDown = true
    local mouse = Inspect.Mouse()
    
    self.originalMouseX = mouse.x
    self.originalMouseY = mouse.y
    
    self.posX = self.originalMouseX - offSetX
    self.posY = self.originalMouseY - offSetY
    
     center:SetPoint("CENTER", UIParent, "CENTER", self.posX, self.posY)
    
  end, center:GetRealName() .. ".Right.Down")
  
  center:EventAttach( Event.UI.Input.Mouse.Cursor.Move, function (self, _, x, y)  
    if self.leftDown ~= true then return end
    local mouseDiffX = x - self.originalMouseX
    local mouseDiffY = y - self.originalMouseY
    
    center:SetPoint("CENTER", UIParent, "CENTER", self.posX + mouseDiffX, self.posY + mouseDiffY)
    nkRadialSetup.x = self.posX + mouseDiffX
    nkRadialSetup.y = self.posY + mouseDiffY
    
  end, center:GetRealName() .. ".Cursor.Move")
  
  center:EventAttach( Event.UI.Input.Mouse.Right.Up, function (self) 
    if self.leftDown ~= true then return end
    self.leftDown = false      
  end, center:GetRealName() .. ".Right.Up")
  
  center:EventAttach( Event.UI.Input.Mouse.Right.Upoutside, function (self)
    if self.leftDown ~= true then return end
    self.leftDown = false    
  end ,center:GetRealName() .. ".Right.Upoutside")
  
  function center:Scale(newScale)
  
    center:SetWidth(75 * newScale)
    center:SetHeight(75 * newScale)
  
  end
  
  function center:SetDesign (design)
    local setup = _designsInner[design] 
    center:SetTextureAsync(setup[1], setup[2])
  end
  
  center:SetDesign(nkRadialSetup.innerDesign)
  
  return center

end

local function _uiButton (name)

  local name = "nkRadial.button." .. name
  local degree, radius = nil, nil
  local tooltipName, tooltipDesc = "", ""
  local type, id

  local stroke = {r = 1, g = 0.847, b = 0, a = 1, thickness = 5 }
  local path = {  {xProportional = 0.5, yProportional = 0}, 
                  {xProportional = 1, yProportional = 0.5, xControlProportional = (61/64), yControlProportional = (3/64)},
                  {xProportional = 0.5, yProportional = 1, xControlProportional = (61/64), yControlProportional = (61/64)},
                  {xProportional = 0, yProportional = 0.5, xControlProportional = (3/64), yControlProportional = (61/64)},
                  {xProportional = 0.5, yProportional = 0, xControlProportional = (3/64), yControlProportional = (3/64)}}
  local fill = {type = 'solid', r = 0, g = 0, b = 0, a = 1}

  local center = EnKai.uiCreateFrame("nkCanvas", name, uiElements.contextSecure)
  local outter = EnKai.uiCreateFrame("nkTexture", name .. ".outter", center)
  local texture = EnKai.uiCreateFrame("nkTexture", name .. ".texture", center)
  local overlay =  EnKai.uiCreateFrame("nkCanvas", name .. ".overlay", center)
  local cooldown = EnKai.uiCreateFrame("nkText", name .. ".cooldown", center)
  
  function center:destroy()
    EnKai.uiAddToGarbageCollector ('nkCanvas', overlay)
    EnKai.uiAddToGarbageCollector ('nkTexture', texture)
    EnKai.uiAddToGarbageCollector ('nkTexture', outter)
    EnKai.uiAddToGarbageCollector ('nkCanvas', center)
  end
  
  center:SetShape(path, fill, {r = 0, g = 0, b = 0, a = 1, thickness = 1 })
  center:SetWidth(36 * nkRadialSetup.scale)
  center:SetHeight(36 * nkRadialSetup.scale)
  center:SetSecureMode("restricted")
  center:SetLayer(1)
  
  --outter:SetTextureAsync("nkRadial", "gfx/center.png")
  outter:SetWidth(65 * nkRadialSetup.scale)
  outter:SetHeight(65 * nkRadialSetup.scale)
  outter:SetPoint("CENTER", center, "CENTER")
  outter:SetSecureMode("restricted")
  outter:SetLayer(1)
  
  texture:SetPoint("CENTER", center, "CENTER")
  texture:SetWidth(24 * nkRadialSetup.scale)
  texture:SetHeight(24 * nkRadialSetup.scale)
  texture:SetSecureMode("restricted")
  texture:SetLayer(2)
  
  overlay:SetPoint("CENTER", texture, "CENTER")
  overlay:SetWidth(28 * nkRadialSetup.scale)
  overlay:SetHeight(28 * nkRadialSetup.scale)
  overlay:SetShape(path, nil, {r = 0, g = 0, b = 0, a = 1, thickness = 5 })
  overlay:SetLayer(3)
  
  cooldown:SetPoint("CENTER", texture, "CENTER")
  cooldown:SetFontSize(16 * nkRadialSetup.scale)
  cooldown:SetFontColor(1, 1, 1, 1)
  cooldown:SetEffectGlow({ colorB = 0, colorA = 1, colorG = 0, colorR = 0, strength = 3, blurX = 3, blurY = 3 })
  cooldown:SetLayer(4)
  cooldown:SetVisible(false)
  
  local oEventMacroSet = center.EventMacroSet
  
  function center:EventMacroSet (handle, macro)
    oEventMacroSet(self, handle, macro)
    texture:EventMacroSet(handle, macro)
    outter:EventMacroSet(handle, macro)
    overlay:EventMacroSet(handle, macro)
  end
  
  function center:SetTexture(addon, path) texture:SetTextureAsync(addon, path) end
  
  function center:SetCooldown(newCooldown)
  
    if newCooldown == nil then
      cooldown:SetVisible(false)
    else  
      cooldown:SetVisible(true)
      cooldown:SetText(newCooldown)
    end
    
  end
  
  function center:Position (newDegree, newRadius)
    
    degree, radius = newDegree, newRadius
    
    if Inspect.System.Secure() == true then return end
    
    if radius == nil then radius = uiElements.center:GetWidth() / 2 end
     
    local x = (radius * math.sin(degree * math.pi / 180))
    local y = (radius * math.cos(degree * math.pi / 180))
        
    center:SetPoint("CENTER", uiElements.center, "CENTER", x, y)
      
  end
  
  function center:GetPosition()
    if degree == nil then degree = 0 end
    return degree
  end
  
  function center:GetRadius()
    if radius == nil then radius = 0 end
    return radius
  end
  
  function center:GetName() return name end
  function center:GetTexture() return texture end
  
  function center:SetType (newType, newId) type, id = newType, newId end
  function center:GetType () return type, id end
  
  
  function center:SetTooltipInfo (name, desc)
    tooltipName, tooltipDesc = name, desc
  end
  
  function center:ActivateTooltip()
  
    overlay:EventAttach(Event.UI.Input.Mouse.Cursor.In, function (self)
        uiElements.tooltip:SetPoint("TOPLEFT", center, "TOPLEFT", 20, 20)
        uiElements.tooltip:Show(tooltipName, tooltipDesc)    
     end, overlay:GetRealName() .. "Mouse.Cursor.In")
      
     overlay:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function (self)
        uiElements.tooltip:SetVisible(false)
     end, overlay:GetRealName() .. "Mouse.Cursor.Out")
     
  end
  
  function center:Scale (newScale)
    
    center:SetWidth(36 * newScale)
    center:SetHeight(36 * newScale)
    
    texture:SetWidth(24 * newScale)
    texture:SetHeight(24 * newScale)
    
    overlay:SetWidth(28 * newScale)
    overlay:SetHeight(28 * newScale)
    
    center:SetDesign(nkRadialSetup.outterDesign)
    
  end
  
  function center:SetDesign (design)
  
    local setup = _designsOutter[design] 
    outter:SetTextureAsync(setup[1], setup[2])
    outter:SetWidth(setup[3] * nkRadialSetup.scale)
    outter:SetHeight(setup[3] * nkRadialSetup.scale)
    center:SetShape(path, setup[4], setup[5])
    overlay:SetVisible(setup[6])
  end
  
  center:SetDesign(nkRadialSetup.outterDesign)
  
  return center

end

--function ui.destroyButtons ()
--
--  for idx = 1, #uiElements.buttons, 1 do
--    
--    for idx2 = 1, 10, 1 do
--      uiElements.buttons[idx].sub[idx2]:destroy()
--    end
--    
--    uiElements.buttons[idx].main:destroy()
--  end
--  
--  uiElements.center:destroy()
--
--end

---------- addon internal function block ---------

function intFct.buildButtons ()

  intFct.configuredButtons = 0
  data.stopAnimation = true
  
  if uiElements.center == nil then

    uiElements.center = _uiCenter()
      
    uiElements.center:EventAttach(Event.UI.Input.Mouse.Left.Down,  function()
    
      if Inspect.System.Secure() == true then return end
    
      if _buttonsShown == false then
         intFct.showButtons ()
         _buttonsShown = true
         
         if nkRadialSetup.timedClose == true then
           _buttonshownTimer = EnKai.events.addInsecure(function() intFct.hideButtons (); _buttonsShown = false; _buttonshownTimer = nil; uiElements.center:SetAlpha(nkRadialSetup.mouseOverAlpha) end, Inspect.Time.Frame(), nkRadialSetup.closingTime)
         end
      else
         intFct.hideButtons ()
         _buttonsShown = false
         
         if _buttonshownTimer ~= nil then EnKai.events.removeInsecure(_buttonshownTimer) end
         _buttonshownTimer = nil
      end
       
    end, uiElements.center:GetName() .. ".Left.Down")
  
    uiElements.buttons = {}
  
  end
  
  uiElements.center:SetAlpha(nkRadialSetup.mouseOverAlpha)
  
  local count = 0
  data.maxButtons = 0
  
  for k, v in pairs (nkRadialSetup.sections) do
  
    if v == true and count < 8 then
    
      count = count + 1
    
      data.maxButtons = data.maxButtons + 1
      local thisButtonNo, newButton, button = count, true, nil
      
      if #uiElements.buttons >= count then
        button, newButton = uiElements.buttons[count].main, false
      else
        button = _uiButton("button" .. count)
      end
      
      button:SetVisible(false)
      if nkRadialSetup.slotIcon[k].type == 'addon' then button:SetTexture("nkRadial", nkRadialSetup.slotIcon[k].path) end

      button:EventDetach(Event.UI.Input.Mouse.Left.Down, nil, button:GetName() .. ".Left.Down")
      button:EventAttach(Event.UI.Input.Mouse.Left.Down, function()
        if Inspect.System.Secure() == true then return end

        if data.buttonSubShown ~= nil then intFct.hideSubButtons(data.buttonSubShown, k) end
    
        if data.buttonSubShown ~= thisButtonNo then
          intFct.showSubButtons (thisButtonNo, k)
          data.buttonSubShown = thisButtonNo
        else
          data.buttonSubShown = nil
        end
       
      end, button:GetName() .. ".Left.Down")
      
      if newButton == true then
      
        local sub = {}
        
        for idx2 = 1, 10, 1 do
          local subButton = _uiButton(button:GetName().. ".sub" ..idx2)
          subButton:SetVisible(false)
          subButton:ActivateTooltip(true)
          
          table.insert(sub, subButton)
        end
        
        table.insert(uiElements.buttons, { main = button, sub = sub, section = k } )
      else
        uiElements.buttons[count].section = k        
      end
    end     
  end
  
  for idx = count + 1, #uiElements.buttons, 1 do uiElements.buttons[idx].main:SetVisible(false) end
  data.stopAnimation = false
  
end

function intFct.changeAngle()

  local baseRadius = uiElements.center:GetWidth() / 2

  local stepDegree = 360 / 8
  local maxDegree = (data.maxButtons-1) * stepDegree + 1
  
  for idx = 1, #uiElements.buttons, 1 do
    local button = uiElements.buttons[idx].main

    local max = (idx -1) * stepDegree + 1 + nkRadialSetup.startAngle
    button:Position (max, baseRadius + button:GetWidth() / 2 )  
  end

end

function intFct.changeScale()

  if data.buttonSubShown ~= nil then intFct.hideSubButtons(data.buttonSubShown) end

  uiElements.center:Scale(nkRadialSetup.scale)
  
  for idx = 1, #uiElements.buttons, 1 do
    local button = uiElements.buttons[idx].main
    button:Scale (nkRadialSetup.scale)
    
    local sub = uiElements.buttons[idx].sub
    
    if sub ~= nil then
      for idx2 = 1, 10, 1 do sub[idx2]:Scale(nkRadialSetup.scale) end
    end
          
  end
  
  intFct.changeAngle()

end

function intFct.tooltip ()

  local tooltip = EnKai.uiCreateFrame("nkTooltip", "nkRadial.tooltip", uiElements.contextSecure)
  
  tooltip:SetLayer(2)  
  
  function tooltip:Show(name, desc)
  
    if name == nil or name == "" then return end
  
    tooltip:SetTitle(name)
    
    if desc ~= nil and desc ~= "" then
      tooltip:SetLines({text = desc})
    else
      tooltip:SetLines({})
    end
    
    tooltip:SetVisible(true)
  end
  
  return tooltip

end